Bullet Collision Detection & Physics Library: btSdfCollisionShape Class Reference

Bullet Collision Detection & Physics Library

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Private Attributes | List of all members
btSdfCollisionShape Class Reference

`#include <btSdfCollisionShape.h>`

Inheritance diagram for btSdfCollisionShape:
[legend]
Collaboration diagram for btSdfCollisionShape:
[legend]

## Public Member Functions
| btSdfCollisionShape ()
virtual | ~btSdfCollisionShape ()
bool | initializeSDF (const char *sdfData, int sizeInBytes)
virtual void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb returns the axis aligned bounding box in the coordinate frame of the given transform t.
virtual void | setLocalScaling (const btVector3 &scaling)
virtual const btVector3 & | getLocalScaling () const
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const
virtual const char * | getName () const
virtual void | setMargin (btScalar margin)
virtual btScalar | getMargin () const
virtual void | processAllTriangles (btTriangleCallback *callback, const btVector3 &aabbMin, const btVector3 &aabbMax) const
bool | queryPoint (const btVector3 &ptInSDF, btScalar &distOut, btVector3 &normal)
Public Member Functions inherited from btConcaveShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConcaveShape ()
virtual | ~btConcaveShape ()
virtual void | processAllTriangles (btTriangleCallback *callback, const btVector3 &aabbMin, const btVector3 &aabbMax) const =0
virtual btScalar | getMargin () const
virtual void | setMargin (btScalar collisionMargin)
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const =0
| getAabb returns the axis aligned bounding box in the coordinate frame of the given transform t.
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximum radius needed for Conservative Advancement to handle time-of-impact with rotations.
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check)
virtual void | setLocalScaling (const btVector3 &scaling)=0
virtual const btVector3 & | getLocalScaling () const =0
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const =0
virtual const char * | getName () const =0
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example
virtual void | setMargin (btScalar margin)=0
virtual btScalar | getMargin () const =0
void | setUserPointer (void *userPtr)
| optional user data pointer
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
void | setUserIndex2 (int index)
int | getUserIndex2 () const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
virtual void | serializeSingleShape (btSerializer *serializer) const

## Private Attributes
struct btSdfCollisionShapeInternalData * | m_data

## Additional Inherited Members
Protected Attributes inherited from btConcaveShape
btScalar | m_collisionMargin
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex
int | m_userIndex2

## Detailed Description

Definition at line 6 of file btSdfCollisionShape.h.

## Constructor & Destructor Documentation

## ◆ btSdfCollisionShape()

btSdfCollisionShape::btSdfCollisionShape | ( |  | ) |

Definition at line 26 of file btSdfCollisionShape.cpp.

## ◆ ~btSdfCollisionShape()

btSdfCollisionShape::~btSdfCollisionShape | ( |  | ) |
| virtual

Definition at line 39 of file btSdfCollisionShape.cpp.

## Member Function Documentation

## ◆ calculateLocalInertia()

void btSdfCollisionShape::calculateLocalInertia | ( | btScalar | mass,
|  | btVector3 & | inertia
| ) |  | const
| virtual

Implements btCollisionShape.

Definition at line 61 of file btSdfCollisionShape.cpp.

## ◆ getAabb()

void btSdfCollisionShape::getAabb | ( | const btTransform & | t,
|  | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax
| ) |  | const
| virtual

getAabb returns the axis aligned bounding box in the coordinate frame of the given transform t.

Implements btCollisionShape.

Definition at line 44 of file btSdfCollisionShape.cpp.

## ◆ getLocalScaling()

const btVector3 & btSdfCollisionShape::getLocalScaling | ( |  | ) | const
| virtual

Implements btCollisionShape.

Definition at line 57 of file btSdfCollisionShape.cpp.

## ◆ getMargin()

btScalar btSdfCollisionShape::getMargin | ( |  | ) | const
| virtual

Reimplemented from btConcaveShape.

Definition at line 73 of file btSdfCollisionShape.cpp.

## ◆ getName()

const char * btSdfCollisionShape::getName | ( |  | ) | const
| virtual

Implements btCollisionShape.

Definition at line 65 of file btSdfCollisionShape.cpp.

## ◆ initializeSDF()

bool btSdfCollisionShape::initializeSDF | ( | const char * | sdfData,
|  | int | sizeInBytes
| ) |  |

Definition at line 21 of file btSdfCollisionShape.cpp.

## ◆ processAllTriangles()

void btSdfCollisionShape::processAllTriangles | ( | btTriangleCallback * | callback,
|  | const btVector3 & | aabbMin,
|  | const btVector3 & | aabbMax
| ) |  | const
| virtual

Implements btConcaveShape.

Definition at line 78 of file btSdfCollisionShape.cpp.

## ◆ queryPoint()

bool btSdfCollisionShape::queryPoint | ( | const btVector3 & | ptInSDF,
|  | btScalar & | distOut,
|  | btVector3 & | normal
| ) |  |

Definition at line 83 of file btSdfCollisionShape.cpp.

## ◆ setLocalScaling()

void btSdfCollisionShape::setLocalScaling | ( | const btVector3 & | scaling | ) |
| virtual

Implements btCollisionShape.

Definition at line 53 of file btSdfCollisionShape.cpp.

## ◆ setMargin()

void btSdfCollisionShape::setMargin | ( | btScalar | margin | ) |
| virtual

Reimplemented from btConcaveShape.

Definition at line 69 of file btSdfCollisionShape.cpp.

## Member Data Documentation

## ◆ m_data

struct btSdfCollisionShapeInternalData* btSdfCollisionShape::m_data
| private

Definition at line 8 of file btSdfCollisionShape.h.

The documentation for this class was generated from the following files:

- btSdfCollisionShape.h
- btSdfCollisionShape.cpp